var request = require('../../utils/request');
var api = require('../../utils/api');
Page({
  data: {
    userName: "",
    pwd: "",
  },
  userNameInput(e) {
    this.setData({
      userName: e.detail.value
    })
  },
  pwdInput(e) {
    this.setData({
      pwd: e.detail.value
    })
  },
  tryAction() {
    wx.navigateTo({
      url: '../tryTry/tryTry'
    })
  },
  loginAction() {
    // admin
    // 123456


    if (this.data.userName.length == 0) {
      wx.showToast({
        title: `请输入账号`,
        icon: 'none',
        duration: 1500
      })
      return;
    }

    if (this.data.pwd.length == 0) {
      wx.showToast({
        title: `请输入密码`,
        icon: 'none',
        duration: 1500
      })
      return;
    }

    wx.showLoading({
      title: '加载中',
    })

    let data = {
      "username": this.data.userName,
      "password": this.data.pwd
    }
    request.Post(api.getoken(), data, function (data) {
      wx.hideLoading();
      if (data.code == "200") {
        wx.setStorage({
          key: 'user',
          data: data.data
        });
        wx.redirectTo({
          url: '../index/index'
        });
      } else {
        wx.showToast({
          title: data.msg,
          icon: 'none',
          duration: 1500
        })
      }
    });
  }
})