const formatTime = date => {
  const year = date.getFullYear()
  const month = date.getMonth() + 1
  const day = date.getDate()
  return [year, month, day].map(formatNumber).join('-')
}

const formatNumber = n => {
  n = n.toString()
  return n[1] ? n : '0' + n
}

// 校验手机号
function testMobile(mobile) {
  var myreg = /^(((13[0-9]{1})|(15[0-9]{1})|(18[0-9]{1})|(17[0-9]{1}))+\d{8})$/;
  return myreg.test(mobile)
};

//  千位符 
// @param x String
function numberWithCommas(x) {
  if (x == undefined || x == 'undefined' || x == null || x == 'null') {
    return "--";
  }
  var pattern = /(-?\d+)(\d{3})/;
  while (pattern.test(x)){
    x = x.replace(pattern, "$1,$2");
  }
  return x;
}

module.exports = {
  formatTime: formatTime,
  testMobile:testMobile,
  numberWithCommas:numberWithCommas
}
