const request = require('../../utils/request');
const api = require('../../utils/api');
const util = require('../../utils/util');

Page({
  data: {
    showNum:"", //展示数
    tapNum:"", // 点击数
    tapOf:"", //  点击率
    todayOff:"",// 今日消耗
    thouMoney:"",//平均千次费用
    oneTick:"", // 平均点击单价
    pocketMoney:"", // 账户余额
    tuiGuang:"", // 推广计划数
    taskNum:"", // 推广任务数
    createNum:"", // 推广创意数
  },
  
  tapAction:function(item){
    let type = item.currentTarget.dataset.type;
    console.log(`type>>>>>${type}`);
    wx.navigateTo({
      url: '../dataView/index'
    })
  },

  onReady() {
    wx.showLoading({
      title: '加载中',
    })
    console.log("onReady>>>>>>>>>>>>>");
    var that = this
    request.Get(api.overview(), function (data) {
      wx.hideLoading();
      if (data.code == "200") {
          if (data.data != null) {
            that.setData({
                showNum:util.numberWithCommas(String(data.data.showNum)), //展示数
                tapNum:util.numberWithCommas(String(data.data.clickNum)), // 点击数
                tapOf:util.numberWithCommas(String(data.data.clickRate)), //  点击率
                todayOff:util.numberWithCommas(String(data.data.consume)),// 今日消耗
                thouMoney:util.numberWithCommas(String(data.data.cpm)),//平均千次费用
                oneTick:util.numberWithCommas(String(data.data.cpc)), // 平均点击单价
                pocketMoney:util.numberWithCommas(String(data.data.balance)), // 账户余额
                tuiGuang:util.numberWithCommas(String(data.data.planNum)), // 推广计划数
                taskNum:util.numberWithCommas(String(data.data.groupNum)), // 推广任务数
                createNum:util.numberWithCommas(String(data.data.creativeNum)), // 推广创意数
            })
          }
        console.log("data>>>>>>>>",JSON.stringify(data));
      } else {
        wx.showToast({
          title: data.msg,
          icon: 'none',
          duration: 1500
        })
      }
    });
  }
})
