var request = require('../../utils/request');
var utils = require('../../utils/util');
var api = require('../../utils/api');
Page({
    data: {
        mobile:"",
        company:"",
        position:"",
        name:""
    },
    mobileInput(e){
      this.setData({
          mobile:e.detail.value
      })  
    },
    companyInput(e){
        this.setData({
            company:e.detail.value
        })  
      },
    positionInput(e){
        this.setData({
            position:e.detail.value
        })  
    },
    nameInput(e){
        this.setData({
            name:e.detail.value
        })
    },
    submitAction(){
        if (this.data.mobile.length == 0) {
            wx.showToast({
              title: `请输入您的手机号`,
              icon: 'none',
              duration: 1500
            })
            return;
        }else{
            if (utils.testMobile(this.data.mobile) == false) {
                wx.showToast({
                    title: `请输入正确的手机号`,
                    icon: 'none',
                    duration: 1500
                  })
                  return;
            }
        }

        if (this.data.company.length == 0) {
            wx.showToast({
                title:'请输入您的公司名称',
                icon: 'none',
                duration: 1500
            })
            return;
        }
        if (this.data.position.length == 0) {
            wx.showToast({
                title:'请输入您的公司职位',
                icon: 'none',
                duration: 1500
            })
            return;
        }
        if (this.data.name.length == 0) {
            wx.showToast({
                title:'请输入您的称呼',
                icon: 'none',
                duration: 1500
            })
            return;
        }
    
        let data = {"customerName":this.data.company,
                    "fullName":this.data.name,
                    "position":this.data.position,
                    "telphone":this.data.mobile}
        request.Post(api.trial(),data,function(data){
            if (data.code == "200") {
                wx.showToast({
                    title:"提交成功",
                    icon: 'none',
                    duration: 1500
                })
                setTimeout(function(){
                    wx.navigateBack();
                },1500);
            }else{
                wx.showToast({
                    title:data.msg,
                    icon: 'none',
                    duration: 1500
                })
            }
        });

    }
})